/**
  * Created by ariellemoro on 12.12.16.
  */

import scala.collection.mutable.{ListBuffer, Map}

class Course(name: String, creditNumber: Int, professor: Professor) extends CourseInterface{

  private var _name: String = name
  private var _creditNumber: Int = creditNumber
  private var _professor: Professor = professor
  private var _examPerformed: Boolean = false
  private var _registrations:ListBuffer[Registration] = new ListBuffer[Registration]

  //Getter: _creditNumber
  def getCreditNumber(): Int = {
    return _creditNumber
  }

  //Funtion that indicates that an exam has been given for this course
  def performExam(): Unit = {
    _examPerformed = true
  }

  //Funtion adding a new registration to the registration array of the course
  def addNewRegistration(registration: Registration): Unit = {
    _registrations += registration
  }

  //Function that displays the stats of the exam
  def displayExamStats(): Unit = {
    if(_examPerformed) {
      var sumGrade: Double = 0.0
      var successNB: Int = 0
      var failureNB: Int = 0
      for (registration <- _registrations) {
        sumGrade += registration.getGrade()
        if (registration.getGrade() >= 4.0) {
          successNB += 1
        } else {
          failureNB += 1
        }
      }
      val successRate = successNB.toDouble / _registrations.length.toDouble
      val failureRate = failureNB.toDouble / _registrations.length.toDouble
      val examMean: Double = sumGrade / _registrations.length.toDouble
      if (_examPerformed) {
        println(s"Exam stats => success rate: $successRate failure rate: $failureRate exam mean: $examMean")
      } else {
        println(s"The exam has not been performed yet!")
      }
    }
  }

  //Getter: _registrations
  def getRegistrations(courseName:String): ListBuffer[Registration] = {
    return _registrations
  }

  //Function setting a grade for a student that was registered for the course
  def setGrade(studentID:Int, grade:Double): Unit = {
    if(_examPerformed) {
      for (registration <- _registrations) {
        var currentStudent: Student = registration.getStudent()
        if (currentStudent.getStudentID == studentID) {
          //Set the grade and if the course is validated for the student
          registration.setGrade(grade)
          if (grade >= 4.0) {
            registration.setValidation()
          } else {
            currentStudent.displayNotification(s"You have failed the course ${_name} with the grade $grade/6.0, you must retake it next year.")
          }
        }
      }
    }
  }

  //Function that ends the semester and reinit some variables
  def finishSemester(): Unit = {
    if(_examPerformed) {
      //Reinit the status of the exam
      _examPerformed = false
      //Clean the registration array
      for (registration <- _registrations) {
        if (registration.getGrade() >= 4.0) {
          _registrations -= registration
        }
      }
    }
  }

  override def toString: String = {
    return s"Course: ${_name} given by ${_professor.toString} - number of credit: ${_creditNumber}"
  }

}
