/**
  * Created by ariellemoro on 12.12.16.
  */

import scala.collection.mutable.{ListBuffer, Map}

class Student(firsname:String, surname:String, studentID:Int) extends UnilMember(firsname, surname) {

  private var _studentID: Int = studentID
  private var _creditNumber: Int = 0
  private var _currentCourses:ListBuffer[Course] = new ListBuffer[Course]
  private var _validatedCourses:ListBuffer[Map[Course, Double]] = new ListBuffer[Map[Course, Double]]

  //Getter: _studentID
  def getStudentID: Int = {
    return studentID
  }

  //Function updating the number of credits obtained by the student
  def updateCreditNumber(creditNumber:Int): Unit = {
    _creditNumber += creditNumber
  }

  //Function adding a new course to the array of courses followed by a student
  def addNewCourse(course: Course): Unit = {
    _currentCourses += course
  }

  //Function that stores the course passed by the student
  def storeCourse(course: Course, grade: Double): Unit = {
    if(_currentCourses.contains(course)) {
      _validatedCourses += Map(course -> grade)
      _currentCourses -= course
    }
  }

  //Funtion that prints a notification received
  def displayNotification(notification:String): Unit ={
    println(s"Notification sent to ${super.toString} => $notification")
  }

  override def toString: String = {
    return s"${super.toString} (student ID: $studentID - ${_creditNumber} credit(s) obtained - current courses: ${_currentCourses.toString()} - validated courses: ${_validatedCourses.toString()})"
  }

}
